// DlgImage.cpp :  Դϴ.
//

#include "stdafx.h"
//#include "GImageDialog.h"
#include <assert.h>
#include "DlgImage.h"
#include "../../CxImage600_Lib/ximage.h"
#include ".\dlgimage.h"
#if _DEBUG
#pragma comment( lib, "../../CxImage600_Lib/Debug/cximage.lib")
#pragma comment( lib, "../../CxImage600_Lib/Debug/jbig.lib")
#pragma comment( lib, "../../CxImage600_Lib/Debug/Jpeg.lib")
#pragma comment( lib, "../../CxImage600_Lib/Debug/png.lib")
#pragma comment( lib, "../../CxImage600_Lib/Debug/Tiff.lib")
#pragma comment( lib, "../../CxImage600_Lib/Debug/zlib.lib")
#else
#pragma comment( lib, "../../CxImage600_Lib/Release/cximage.lib")
#pragma comment( lib, "../../CxImage600_Lib/Release/jbig.lib")
#pragma comment( lib, "../../CxImage600_Lib/Release/Jpeg.lib")
#pragma comment( lib, "../../CxImage600_Lib/Release/png.lib")
#pragma comment( lib, "../../CxImage600_Lib/Release/Tiff.lib")
#pragma comment( lib, "../../CxImage600_Lib/Release/zlib.lib")
#endif //


// CDlgImage ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgImage, CDialog)
CDlgImage::CDlgImage(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgImage::IDD, pParent)
{
}

CDlgImage::CDlgImage( CString pathName, int maxWidth, int maxHeight, CWnd* pParent )
	: CDialog(CDlgImage::IDD, pParent)
{
	m_pathName = pathName;
	m_maxWidth = maxWidth;
	m_maxHeight = maxHeight;
	TRACE( "̹ :%s\n", m_pathName.GetBuffer( m_pathName.GetLength() ) );
}


CDlgImage::~CDlgImage()
{
}

void CDlgImage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDlgImage, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CDlgImage ޽ óԴϴ.

void CDlgImage::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnOK();
}

void CDlgImage::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnCancel();
}

//#define CXIMAGE_SUPPORT_BMP
//#define CXIMAGE_SUPPORT_GIF
//#define CXIMAGE_SUPPORT_JPG
//#define CXIMAGE_SUPPORT_PNG
//#define CXIMAGE_SUPPORT_ICO
//#define CXIMAGE_SUPPORT_TIF
//#define CXIMAGE_SUPPORT_TGA

BOOL CDlgImage::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetWindowPos( NULL, 0, 0, m_maxWidth, m_maxHeight, SWP_NOMOVE );

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CDlgImage::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	// ̹ 
	CxImage image( m_pathName.GetBuffer( m_pathName.GetLength() ), CXIMAGE_SUPPORT_JPG );
	if( image.IsValid() == false )
	{
//		assert( image.IsValid() && "̹ о  ߽ϴ." );
		dc.TextOut( 2, 2, "ؽó " );
		return;
	}

	// ȭ   ´.
	// ׸ width, height  ִ ũ⸦  ͼ
	//   ŭ ũٸ ø ϵ Ѵ.
	CRect rect;
	GetClientRect( rect );

	if( rect.Width() < (int)image.GetWidth() || rect.Height() < (int)image.GetHeight() )
	{
		//  ø
		float width = (float)image.GetWidth();
		float height = (float)image.GetHeight();

		float fx = width / (float)rect.Width();
		float fy = height / (float)rect.Width();
		float f = 0;

		if( fx > fy )
			f = fx;
		else
			f = fy;

		if( f < 1 )
			f = 1;

		float newWidth = (float)( width / f );
		float newHeight = (float)( height / f );

		image.Resample( (long)newWidth, (long)newHeight, 4 );
	}

	image.Draw( dc.GetSafeHdc() );
}
